> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.runpayments.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.runpayments.io/_mcp/server.

# Charge

POST https://javelin.runpayments.io/api/v1/charge
Content-Type: application/json

Process a payment charge with card details and additional transaction information.

> **Disclaimer:** This documentation combines requirements from all compatible payment gateways. Not all fields or requirements may apply to your specific integration. For questions about your setup, contact [integrations@runpayments.io](mailto:integrations@runpayments.io).

**Cybersource Gateway:** The following additional fields are required when processing through Cybersource: `name`, `address2`, `region`, `country`, `phone`, `email`.


Reference: https://docs.runpayments.io/reference/payments-api/process-charge

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Body (application/json)

This endpoint expects an object.

- `account_token` (string, required) — Tokenized payment account number. Generated from Runner.js or Run Merchant dev tools.
- `mid` (string, required) — Merchant ID
- `amount` (integer, required) — Ticket amount (in cents)
- `expiration` (string, required) — Card expiration
- `account_zip` (string, required) — Cardholder zip code
- `cvn` (string, required) — Cardholder CVN (CVV2, CID, CAV2, CVC2)
- `currency` (string, required) — Three character currency indicator (Defaults to USD)
- `address1` (string, required) — Account holder's street address
- `city` (string, required) — Account holder's city
- `cof` (string, optional) — Returns cof value if included in auth request.
- `user_identifier` (string, optional) — The user that initiated the activity.
- `cof_perm` (string, optional) — Permission granted to save card on file for a specific profile (Y or N)
- `terminal_id` (string, optional) — The terminal ID as identified in the auth request.
- `cof_sched` (string, optional) — Required for transactions using stored cardholder payment information. For a merchant-initiated transaction (MIT), the cof_sched parameter specifies whether the transaction is a one-time payment or a scheduled recurring payment.
- `card_bin` (string, optional) — Return BIN lookup fields in response
- `customer` (string, optional) — Customer ID
- `capture` (string, optional) — Capture upon approval (Y or N)
- `name` (string, optional) — Account holder's name
- `company_name` (string, optional) — Account holder's company name
- `address2` (string, optional) — Account holder's street address line 2
- `region` (string, optional) — Account holder's region, US State, Mexican State, or Canadian Province
- `country` (string, optional) — Account holder's country (2-character country code)
- `phone` (string, optional) — Account holder's phone number
- `email` (string, optional) — Account holder's email address
- `com_ind` (enum, optional) — CNP transaction origin. Optional, but strongly encouraged, as this field is used to ensure a transaction qualifies at the correct interchange level. Valid values: `R` (recurring), `T` (telephone), `E` (ecomm or mobile app).
  - Allowed values: `R`, `T`, `E`
- `order_id` (string, optional) — Unique source system order number, if left blank it will be generated for you
- `invoice_id` (string, optional) — User-defined invoice identifier.
- `auth_code` (string, optional) — Authorization Code
- `vault` (string, optional) — Indicates if the payment account should be saved in the vault (Y or N)
- `po_number` (string, optional) — Customer purchase order number
- `tax_amount` (string, optional) — Tax amount for the order, either decimal or in currency minor units. If taxexempt is Y, then 0.
- `freight_amount` (string, optional) — Total order freight amount, default 0
- `duty_amount` (string, optional) — Total order duty amount, default 0
- `order_date` (string, optional) — YYYYMMDD format. For most industries this is the delivery date for the order.
- `shipping_zip` (string, optional) — If country is US, must be 5 or 9 digits. Otherwise, any alphanumeric string is accepted
- `origin_zip` (string, optional) — Same as above
- `shipping_country` (string, optional) — Ship to country code - Defaults to US
- `line_items` (list of any, optional) — Level 3 Processing Line Items
- `vault_id` (integer, optional) — The id for the vault card
- `vault_holder_id` (string, optional) — This is the vault customer ID that is returned once a vault is created. When included in the request, it will store the vault account with the specified vault holder. See the [Vaults guide](/docs/guides/payments/vaults) for more information.
- `custom_01` (string, optional) — Transaction-level custom field. custom_01 through custom_05 are available for use at the transaction level. See [Custom Fields](/docs/guides/payments/custom-fields#transaction-custom-fields) for more information.
- `custom_06` (string, optional) — Account-level custom field. custom_06 through custom_10 are available for use at the account level. See [Custom Fields](/docs/guides/payments/custom-fields#account-custom-fields) for more information.

## Response

### 200

Charge processed successfully

- `trans_id` (string, required) — Reference number for the transaction
- `vault_id` (integer, required) — The id for the vault card
- `vault_holder_id` (string, required) — The vault customer ID
- `result` (enum, required) — Result of auth request. A = Approved, B = Retry, C = Declined.
  - Allowed values: `A`, `B`, `C`
- `account_token` (string, required) — Tokenized payment account number.
- `resp_code` (string, required) — Response code that represents description of the response.
- `resp_text` (string, required) — Text description of response
- `resp_proc` (string, required) — Abbreviation that represents platform and processor for transaction
- `cof` (string, required) — Returns cof value if included in auth request
- `avs_resp` (string, required) — AVS verification response code
- `cvv_resp` (string, required) — CVV response code
- `bin_info` (string, required) — Array that returns fields from BIN response
- `bin_type` (string, required) — Type of BIN
- `pos_entry` (string, required) — POS Entry Mode
- `fee_amount` (integer, required) — A fee amount (e.g. a credit card surcharge amount) applied to the transaction, in dollars and cents.
- `fee_authcode` (string, required) — Duplicate of authcode field if the transaction included a fee
- `fee_format` (string, required) — Fee format configured for merchant account.
- `fee_mid` (string, required) — MID used for processing the fee. If not applicable, returns an empty value.
- `fee_txn` (string, required) — Unique reference number used for processing fee. If not applicable, returns an empty value
- `fee_type` (string, required) — Type of fee applied to transaction
- `fee_value` (string, required) — Fee rate applied to the transaction (in basis points)
- `decline_category` (string, required) — Visa decline category
- `decline_category_text` (string, required) — Visa decline category description
- `authcode` (string, required) — Authcode from issuer
- `comm_card` (string, required) — Commercial card flag - Y if corporate or purchase card
- `emv` (string, required) — Cryptogram (ARPC) only returned when emv data is present
- `emv_tag_data` (string, required) — Receipt/EMV tag data
- `user_identifier` (string, required) — The user that initiated the activity
- `mid` (string, required) — Merchant ID
- `amount` (integer, required) — Ticket amount
- `expiration` (string, required) — Card expiration
- `account_zip` (string, required) — Cardholder zip
- `address1` (string, required) — Account holder's street address
- `city` (string, required) — Account holder's city
- `region` (string, required) — Account holder's region, US State, Mexican State, Canadian Province
- `order_id` (string, required) — Source system order number
- `card_number` (string, required) — Masked primary account number (PAN)
- `batch_id` (string, required) — Automatically created and assigned unless otherwise specified
- `vault` (string, required) — Indicates if the payment account was saved in the vault (Y or N)
- `card_type` (string, required) — Visa, MC, Discover, Amex, etc.
- `currency` (string, required) — Three character currency indicator
- `company_name` (string, required) — Account holder's company name
- `address2` (string, required) — Account holder's street address line 2
- `country` (string, required) — Account holder's country - 2-character country code
- `phone` (string, required) — Account holder's phone
- `email` (string, required) — Account holder's email
- `auth_code` (string, required) — Authorization code from issuer

## Errors

### 400 Bad Request Error

Bad request

- `error` (string, optional) — Error code
- `error_description` (string, optional) — Detailed error description

### 401 Unauthorized Error

Unauthorized

- `error` (string, optional) — Error code
- `error_description` (string, optional) — Detailed error description

## Examples

**Request**

```json
{
  "account_token": "string",
  "mid": "string",
  "amount": 1,
  "expiration": "string",
  "account_zip": "string",
  "cvn": "string",
  "currency": "string",
  "address1": "string",
  "city": "string"
}
```

**Response**

```json
{
  "trans_id": "string",
  "vault_id": 1,
  "vault_holder_id": "string",
  "result": "A",
  "account_token": "string",
  "resp_code": "string",
  "resp_text": "string",
  "resp_proc": "string",
  "cof": "string",
  "avs_resp": "string",
  "cvv_resp": "string",
  "bin_info": "string",
  "bin_type": "string",
  "pos_entry": "string",
  "fee_amount": 1,
  "fee_authcode": "string",
  "fee_format": "string",
  "fee_mid": "string",
  "fee_txn": "string",
  "fee_type": "string",
  "fee_value": "string",
  "decline_category": "string",
  "decline_category_text": "string",
  "authcode": "string",
  "comm_card": "string",
  "emv": "string",
  "emv_tag_data": "string",
  "user_identifier": "string",
  "mid": "string",
  "amount": 1,
  "expiration": "string",
  "account_zip": "string",
  "address1": "string",
  "city": "string",
  "region": "string",
  "order_id": "string",
  "card_number": "string",
  "batch_id": "string",
  "vault": "string",
  "card_type": "string",
  "currency": "string",
  "company_name": "string",
  "address2": "string",
  "country": "string",
  "phone": "string",
  "email": "string",
  "auth_code": "string"
}
```

**SDK Code**

```python
import requests

url = "https://javelin.runpayments.io/api/v1/charge"

payload = {
    "account_token": "string",
    "mid": "string",
    "amount": 1,
    "expiration": "string",
    "account_zip": "string",
    "cvn": "string",
    "currency": "string",
    "address1": "string",
    "city": "string"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://javelin.runpayments.io/api/v1/charge';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"account_token":"string","mid":"string","amount":1,"expiration":"string","account_zip":"string","cvn":"string","currency":"string","address1":"string","city":"string"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://javelin.runpayments.io/api/v1/charge"

	payload := strings.NewReader("{\n  \"account_token\": \"string\",\n  \"mid\": \"string\",\n  \"amount\": 1,\n  \"expiration\": \"string\",\n  \"account_zip\": \"string\",\n  \"cvn\": \"string\",\n  \"currency\": \"string\",\n  \"address1\": \"string\",\n  \"city\": \"string\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://javelin.runpayments.io/api/v1/charge")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"account_token\": \"string\",\n  \"mid\": \"string\",\n  \"amount\": 1,\n  \"expiration\": \"string\",\n  \"account_zip\": \"string\",\n  \"cvn\": \"string\",\n  \"currency\": \"string\",\n  \"address1\": \"string\",\n  \"city\": \"string\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://javelin.runpayments.io/api/v1/charge")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"account_token\": \"string\",\n  \"mid\": \"string\",\n  \"amount\": 1,\n  \"expiration\": \"string\",\n  \"account_zip\": \"string\",\n  \"cvn\": \"string\",\n  \"currency\": \"string\",\n  \"address1\": \"string\",\n  \"city\": \"string\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://javelin.runpayments.io/api/v1/charge', [
  'body' => '{
  "account_token": "string",
  "mid": "string",
  "amount": 1,
  "expiration": "string",
  "account_zip": "string",
  "cvn": "string",
  "currency": "string",
  "address1": "string",
  "city": "string"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://javelin.runpayments.io/api/v1/charge");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"account_token\": \"string\",\n  \"mid\": \"string\",\n  \"amount\": 1,\n  \"expiration\": \"string\",\n  \"account_zip\": \"string\",\n  \"cvn\": \"string\",\n  \"currency\": \"string\",\n  \"address1\": \"string\",\n  \"city\": \"string\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "account_token": "string",
  "mid": "string",
  "amount": 1,
  "expiration": "string",
  "account_zip": "string",
  "cvn": "string",
  "currency": "string",
  "address1": "string",
  "city": "string"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://javelin.runpayments.io/api/v1/charge")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```